#!/usr/bin/env python
import sys

from os import path

#BASIC Options
#TITLE = 'data size v.s. ROC'
XLABEL = 'updates'
XLABEL = 'time'
#XLABEL = 'rank'
XLABEL = 'cputime'
XLABEL = 'iter'
XLABEL = 'walltime'
XLABEL = 'time'
XLABEL = 'alpha'

YLABEL = 'cputime'
YLABEL = 'training-LL'
YLABEL = 'walltime'
YLABEL = r'acc'
YLABEL = r'f'
YLABEL = r'obj'
YLABEL = r'hlu'

FILETYPE = 'png'
TITLE = '%s v.s. %s ' % (XLABEL, YLABEL)

xmax = 45
xmax = 300
xmax = 20
xmax = 2.5e+7
xmax = 1500
xmax = 60
xmax = 0

ymax = 0

COLORS = 'blue,red,black,green,cyan,magenta,chartreuse,blueviolet,forestgreen,black,aqua'.split(',')
LINESTYLES = '-,--,-.,:'.split(',')
MARKERS = 'o,s,^,v,*,+,x,.'.split(',')
mycolor = lambda i: COLORS[i%len(COLORS)]
mylinestyle = lambda i: LINESTYLES[i%len(LINESTYLES)]
mymarker = lambda i: MARKERS[i%len(MARKERS)]

logs = sys.argv[1:]

def getlegend(log):
	if '-' in log: return r'$\bar\rho={0}$'.format(log.split('-')[-1])
	else: return log

def getcoord(log):
	x = []
	y = []
	for line in open(log, 'r'):
		if line.strip() == "" : continue
		if XLABEL == 'rank':
			if 'oiter 1 ' not in line: continue
		line = line.split()
		if XLABEL not in line or YLABEL not in line : continue
		idx = line[::2].index(XLABEL)
		x += [line[1::2][idx]]
		idx = line[::2].index(YLABEL)
		y += [line[1::2][idx]]
	x = map(float, x)
	#x = [float(s)+inittime for s in x]
	y = map(float, y)
	return [x, y, log]

def transform2reletive(curves):
	m = min(map(lambda x: min(x[1]) , curves))
	for i in range(len(curves)):
		curves[i][1] = map(lambda x: abs((x - m)/m), curves[i][1])

def scale(curves, s):
	for i in range(len(curves)):
		curves[i][1] = [float(s)*(iter+1)/x for iter, x in enumerate(curves[i][1])]
		#curves[i][1] = map(lambda x: s/x, enumerate(curves[i][1]))

def draw(curves, dataname, hline):
	global xmax, ymax
	import matplotlib
	matplotlib.use('Agg')
	matplotlib.rc('text',usetex=True)
	matplotlib.rc('font',family='serif')
	from matplotlib import pylab
	#params = {'font.size': 18, 'axes.labelsize': 18, 'font.size': 18, 'legend.fontsize': 16,'xtick.labelsize': 14,'ytick.labelsize': 14, 'axes.formatter.limits':(-3,3)}
	params = {'font.size': 22, 'axes.labelsize': 22, 'font.size': 22, 'legend.fontsize': 22,'xtick.labelsize': 18,'ytick.labelsize': 18, 'axes.formatter.limits':(-3,3)}
	pylab.rcParams.update(params)

	pylab.figure()
	plots = []
	#pylab.axhline(y=hline, lw=1, c='gray', marker='.')
	for i in range(len(curves)):
		#change 'plot' to 'semilogx'/'semilogy'/'loglog' if you need it
		#if dataname.lower() in ['news20', 'covtype', 'rcv1']: plotter = pylab.semilogx
		#else: plotter = pylab.plot
		#plotter = pylab.loglog
		plotter = pylab.semilogy
		plotter = pylab.plot
		plotter = pylab.semilogx
		if 'liblinear' in curves[i][2]:
			tmp,= plotter(curves[i][0], curves[i][1],
					lw=3, c=mycolor(5), ls=mylinestyle(5))
		else :
			tmp,= plotter(curves[i][0], curves[i][1],
					lw=3, c=mycolor(i), ls=mylinestyle(i), basex=2)
					#lw=3, c=mycolor(i), ls=mylinestyle(i))
		plots += [tmp]
		#pylab.axvline(x=894956000)

	pylab.xticks(2.0**pylab.arange(-20,5,4))
	pylab.tick_params(labelsize='large')
	if xmax!=0: pylab.xlim(xmax=xmax)
	if ymax!=0: pylab.ylim(ymax=ymax)
	pylab.ylim(ymin=1e-6)
	if dataname.lower() == 'news20':
		pylab.xlim(xmin=10**(-1.3))
	elif dataname.lower() == 'covtype':
		pylab.xlim(xmin=10**(-1.8))
	elif dataname.lower() == 'rcv1':
		pylab.xlim(xmin=10**(-1.2))
		#pylab.ylim(ymin=85)
#	if 'rmse' in YLABEL: pylab.ylim(ymax=1.0)
	#if 'obj' in YLABEL: pylab.ylim(ymax=1e-8)
	#pylab.ylim(ymin=0)

	pylab.xlabel(r'$\alpha$', fontsize='large')
	if YLABEL.upper().startswith('NDCG'):
		pylab.ylabel(r'n{0}'.format(YLABEL.upper()[1:]), fontsize='large')
	elif YLABEL.upper() == 'HLU':
		pylab.ylabel(r'nHLU', fontsize='large')
	else :
		pylab.ylabel(r'{0}'.format(YLABEL.upper()), fontsize='large')
	#pylab.xlabel('Iterations', fontsize='large')
	#pylab.xlabel('CPU Time (s)', fontsize='large')
	#pylab.ylabel('Speedups', fontsize='large')
	#pylab.title(r'{\sf synthetic} -- $\lambda = %s$'%(dataname[1:]), fontsize='large')
	pylab.title(r'{\sf synthetic}', fontsize='large')
	pylab.legend(plots, map(lambda x: getlegend(x[2]), curves), loc='best')
	#pylab.legend(map(lambda x: getlegend(x[2]), curves), loc='center right')
	#pylab.savefig('figs/syn-%s-%s-comp-alpha.%s'%(dataname.lower(), YLABEL, FILETYPE), format=FILETYPE,bbox_inches='tight')
	pylab.savefig('figs/syn-%s-%s-comp-alpha.%s'%(dataname.lower(), YLABEL.lower(), FILETYPE), format=FILETYPE,bbox_inches='tight')
	#pylab.savefig('figs/%s-comp-obj.%s'%(dataname.lower(), FILETYPE), format=FILETYPE)

def go_one(data,dataname, threads, solver):
	logs = []
	for s in solver:
		logs += ['alpha-logs/%s-%s'%(data,s.lower())]
	curves = map(getcoord, logs)
	#transform2reletive(curves)
	draw(curves, dataname, 0)

solver = ['0.95', '0.1', '0.05', '0.01']
data_list = ['final', 'final500', 'final1000', 'final5000']
data_list = ['final500', 'final1000', 'final5000']
data_list = ['final500']
data_list = ['final500', 'final1000']
YLABEL_list = ['hlu', 'map', 'ndcg@10','ndcg@5', 'ndcg@1', 'auc']

xmax = 2**4
for y in YLABEL_list:
	YLABEL = y
	for d in data_list:
		go_one(d, d, 10, solver)

