function [ret, ret_opt] = get_best(res, init, init_opt)
	keys = {'user', 'item_f', 'item_w', 'item_s', 'uniform', 'pu', 'bpr'};
	best = cell(size(keys));
	best_opt = cell(size(keys));
	for tt = 1:length(keys)
		if nargin == 1
			best{tt} = struct('map',0,'auc',0,'hlu',0,'ndcg1',0,'ndcg5',0,'ndcg10',0);
			best_opt{tt} = struct('map','','auc','','hlu','', 'ndcg1','','ndcg5','','ndcg10','');
		else 
			best{tt} = getfield(init,keys{tt});
			best_opt{tt} = getfield(init_opt,keys{tt});
		end
	end

	names = fieldnames(res);
	for i = 1:length(names)
		m = getfield(res, names{i});
		names2 = fieldnames(m);
		for j = 1:length(names2)
			str = names2{j};
			m2 = getfield(m, str);
			key_id = 0;
			for tt = 1:length(keys)
				if(length(strfind(str, keys{tt}))> 0)	
					key_id = tt;
					break
				end
			end

			b = best{key_id};
			if b.map < m2.map
				best{key_id}.map = m2.map;
				best_opt{key_id}.map = [names{i} names2{j}];
			end
			if b.auc < m2.auc
				best{key_id}.auc = m2.auc;
				best_opt{key_id}.auc = [names{i} names2{j}];
			end
			if b.hlu < m2.hlu
				best{key_id}.hlu = m2.hlu;
				best_opt{key_id}.hlu = [names{i} names2{j}];
			end
			if b.ndcg1 < m2.ndcg(1)
				best{key_id}.ndcg1 = m2.ndcg(1);
				best_opt{key_id}.ndcg1 = [names{i} names2{j}];
			end
			if b.ndcg10 < m2.ndcg(10)
				best{key_id}.ndcg10 = m2.ndcg(10);
				best_opt{key_id}.ndcg10 = [names{i} names2{j}];
			end
			if b.ndcg5 < m2.ndcg(5)
				best{key_id}.ndcg5 = m2.ndcg(5);
				best_opt{key_id}.ndcg5 = [names{i} names2{j}];
			end
		end
	end

	ret = struct();
	for tt = 1: length(keys)
		ret = setfield(ret, keys{tt}, best{tt});
	end
	ret_opt = struct();
	for tt = 1: length(keys)
		ret_opt = setfield(ret_opt, keys{tt}, best_opt{tt});
	end
end
