#/bin/bash

# Convert data to binary format for fast loading
./converter txt-data/ml1m-oc2
./converter txt-data/ml10m-oc2
if [ -r txt-data/netflix-oc2 ]; then
./converter txt-data/netflix-oc2
fi
if [ -r txt-data/yahoo-oc2 ]; then
./converter txt-data/yahoo-oc2
fi

########### Full Approach #############
# CCD
./omp-pmf-train -b 0 -p 1 -f 1 -k 64 -l 0.1 -r 0.1 -n 1 -t 25 -s 10 txt-data/ml1m-oc2/ > logs/ml1m-ccd
./omp-pmf-train -b 0 -p 1 -f 1 -k 64 -l 0.1 -r 0.1 -n 1 -t 25 -s 10 txt-data/ml10m-oc2/ > logs/ml10m-ccd
if [ -r txt-data/netflix-oc2 ]; then
./omp-pmf-train -b 0 -p 1 -f 1 -k 64 -l 0.1 -r 0.1 -n 1 -t 25 -s 10 txt-data/netflix-oc2/ > logs/netflix-ccd
fi 
if [ -r txt-data/yahoo-oc2 ]; then
./omp-pmf-train -b 0 -p 1 -f 1 -k 64 -l 0.1 -r 0.1 -n 1 -t 25 -s 10 txt-data/yahoo-oc2/ > logs/yahoo-ccd
fi

# ALS
./omp-pmf-train -b 0 -p 1 -f 1 -k 64 -l 0.1 -r 0.1 -n 1 -t 50 -s 11 txt-data/ml1m-oc2/ > logs/ml1m-als
./omp-pmf-train -b 0 -p 1 -f 1 -k 64 -l 0.1 -r 0.1 -n 1 -t 50 -s 11 txt-data/ml10m-oc2/ > logs/ml10m-als
if [ -r txt-data/netflix-oc2 ]; then
./omp-pmf-train -b 0 -p 1 -f 1 -k 64 -l 0.1 -r 0.1 -n 1 -t 50 -s 11 txt-data/netflix-oc2/ > logs/netflix-als
fi
if [ -r txt-data/yahoo-oc2 ]; then
./omp-pmf-train -b 0 -p 1 -f 1 -k 64 -l 0.1 -r 0.1 -n 1 -t 50 -s 11 txt-data/yahoo-oc2/ > logs/yahoo-als
fi

# SG-Reform 
./omp-pmf-train -b 0 -p 1 -f 1 -k 64 -l 0.1 -r 0.1 -n 1 -B 1 -t 50 -s 12 -P 2 txt-data/ml1m-oc2/ > logs/ml1m-sgd
./omp-pmf-train -b 0 -p 1 -f 1 -k 64 -l 0.1 -r 0.1 -n 1 -B 1 -t 50 -s 12 -P 2 txt-data/ml10m-oc2/ > logs/ml10m-sgd
#if [ -r txt-data/netflix-oc2 ]; then
#./omp-pmf-train -b 0 -p 1 -f 1 -k 64 -l 0.1 -r 0.1 -n 1 -B 1 -t 50 -s 12 -P 2 txt-data/netflix-oc2/ > logs/netflix-sgd
#fi
#if [ -r txt-data/yahoo-oc2 ]; then
#./omp-pmf-train -b 0 -p 1 -f 1 -k 64 -l 0.1 -r 0.1 -n 1 -B 1 -t 50 -s 12 -P 2 txt-data/yahoo-oc2/ > logs/yahoo-sgd
#fi

# SG-BSearch 
./omp-pmf-train -b 0 -p 1 -f 1 -k 64 -l 0.1 -r 0.1 -n 1 -B 1 -t 50 -s 12 -P 6 txt-data/ml1m-oc2/ > logs/ml1m-sgd.slow
./omp-pmf-train -b 0 -p 1 -f 1 -k 64 -l 0.1 -r 0.1 -n 1 -B 1 -t 50 -s 12 -P 6 txt-data/ml10m-oc2/ > logs/ml10m-sgd.slow
#if [ -r txt-data/netflix-oc2 ]; then
#./omp-pmf-train -b 0 -p 1 -f 1 -k 64 -l 0.1 -r 0.1 -n 1 -B 1 -t 50 -s 12 -P 6 txt-data/netflix-oc/ > logs/netflix-sgd.slow
#fi
#if [ -r txt-data/yahoo-oc2 ]; then
#./omp-pmf-train -b 0 -p 1 -f 1 -k 64 -l 0.1 -r 0.1 -n 1 -B 1 -t 50 -s 12 -P 6 txt-data/yahoo-oc/ > logs/yahoo-sgd.slow
#fi
#
# SGD-Dense
./converter txt-data/ml1m-oc2-full
./converter txt-data/ml10m-oc2-full
./pmf-train -b 0 -p 1 -f 1 -k 64 -l 0.1 -r 0.1 -n 1 -B 1 -t 50 -s 22 txt-data/ml1m-oc2-full/ > logs/ml1m-sgd.orig
./pmf-train -b 0 -p 1 -f 1 -k 64 -l 0.1 -r 0.1 -n 1 -B 1 -t 50 -s 22 txt-data/ml10m-oc2-full/ > logs/ml10m-sgd.orig

########### Subsampled Approach #############
# Convert data to binary format for fast loading

./converter txt-data/ml1m-oc2s1
./converter txt-data/ml10m-oc2s1

# CCD
./omp-pmf-train -b 0 -p 1 -f 1 -k 64 -l 0.1 -r 0.1 -n 1 -t 25 -s 0 txt-data/ml1m-oc2s1/ > logs/ml1m-ccd.s1
./omp-pmf-train -b 0 -p 1 -f 1 -k 64 -l 0.1 -r 0.1 -n 1 -t 25 -s 0 txt-data/ml10m-oc2s1/ > logs/ml10m-ccd.s1

# ALS
./omp-pmf-train -b 0 -p 1 -f 1 -k 64 -l 0.1 -r 0.1 -n 1 -t 50 -s 1 txt-data/ml1m-oc2s1/ > logs/ml1m-als.s1
./omp-pmf-train -b 0 -p 1 -f 1 -k 64 -l 0.1 -r 0.1 -n 1 -t 50 -s 1 txt-data/ml10m-oc2s1/ > logs/ml10m-als.s1

# SG
./omp-pmf-train -b 0 -p 1 -f 1 -k 64 -l 0.1 -r 0.1 -n 1 -B 1 -t 50 -s 2 txt-data/ml1m-oc2s1/ > logs/ml1m-sgd.s1
./omp-pmf-train -b 0 -p 1 -f 1 -k 64 -l 0.1 -r 0.1 -n 1 -B 1 -t 50 -s 2 txt-data/ml10m-oc2s1/ > logs/ml10m-sgd.s1
